Index: palm/trunk/TESTS/cases/warm_air_bubble_with_bcm/MONITORING/warm_air_bubble_with_bcm_rc
===================================================================
--- palm/trunk/TESTS/cases/warm_air_bubble_with_bcm/MONITORING/warm_air_bubble_with_bcm_rc	(revision 3662)
+++ palm/trunk/TESTS/cases/warm_air_bubble_with_bcm/MONITORING/warm_air_bubble_with_bcm_rc	(revision 3663)
@@ -1,10 +1,10 @@
 
  ******************************    --------------------------------------------
- * PALM 5.0  Rev: 3447        *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 3660:36     *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:                 29-10-18    Run:       warm_air_bubble_with_bcm__gfortran
- Time:                 17:37:46    Run-No.:   00
- Run on host:        gfortran_d
+ Date:               2019-01-08    Run:       warm_air_bubble_with_bcm          
+ Time:                 20:35:31    Run-No.:   00
+ Run on host:        lcmuk_para
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
  ------------------------------------------------------------------------------
@@ -22,5 +22,4 @@
  --> Time differencing scheme: runge-kutta-3       
  --> Additional prognostic equation for the total water content
- --> Additional prognostic equation for a passive scalar
  ------------------------------------------------------------------------------
 
@@ -92,11 +91,5 @@
  T. bound.: q(nzt+1) = q(nzt) + dq/dz                                                            
 
-                     s
-
- B. bound.: s(0)      = s(1)                                                                     
- T. bound.: s(nzt+1) = s(nzt) + ds/dz                                                            
-
  Bottom surface fluxes are used in diffusion terms at k=1
-       Predefined constant scalar flux:  0.200E-02 kg/(m**2 s)
 
 
@@ -131,11 +124,4 @@
        Gridpoint:          0         0        15        39
 
-    Characteristic levels of the initial scalar profile:
-
-       Height:                       0.0       0.0  m
-       Scalar concentration:     0.8E-03   0.8E-03  kg/m**3
-       Gradient:                --------   0.0E+00  (kg/m**3)/100m
-       Gridpoint:                      0         0
-
 
  List output:
@@ -158,7 +144,5 @@
 
 
-       Profile: u, v, w, ql, theta, w"theta", w*theta*, wtheta, w*2,         
-
-              : theta*2,                                                     
+       Profile: u, v, ql, theta, w"theta", w*theta*, wtheta, w*2,            
        Output every               400.00 s
        Time averaged over         100.00 s
@@ -187,5 +171,5 @@
 
 
-       YZ-cross-section  Arrays:  ql, qr, nr, w, u, v, s,                                              
+       YZ-cross-section  Arrays:  ql, qr, nr, w, u, v,                                                 
        Output every               400.00 s  
        Cross sections at i = /-1/10/
@@ -213,5 +197,5 @@
                             f*     =  0.000084 1/s
 
-    Day of the year at model start :   day_init      =       0
+    Day of the year at model start :   day_init      =     172
     UTC time at model start        :   time_utc_init = 43200.0 s
 
@@ -219,4 +203,27 @@
 
     Reference state used in buoyancy terms: initial_profile
+
+
+ Cloud physics quantities / methods:
+ ----------------------------------
+
+
+
+ LES / Turbulence quantities:
+ ---------------------------
+
+    Mixing length is limited to 1.80 * z
+
+
+ Actions during the simulation:
+ -----------------------------
+
+    Disturbance impulse (u,v) every :   150.00 s
+    Disturbance amplitude           :     0.25 m/s
+    Lower disturbance level         :   125.00 m (GP    3)
+    Upper disturbance level         :   625.00 m (GP   13)
+    Disturbances cease as soon as the disturbance energy exceeds 0.010 m**2/s**2
+    Random number generator used    : random-parallel
+
 
 
@@ -240,27 +247,4 @@
        Droplet density              :   N_c   =   70.0 1/cm**3
        Sedimentation Courant number :   C_s   =  2.0
-
-
- Cloud physics quantities / methods:
- ----------------------------------
-
-
-
- LES / Turbulence quantities:
- ---------------------------
-
-    Mixing length is limited to 1.80 * z
-
-
- Actions during the simulation:
- -----------------------------
-
-    Disturbance impulse (u,v) every :   150.00 s
-    Disturbance amplitude           :     0.25 m/s
-    Lower disturbance level         :   125.00 m (GP    3)
-    Upper disturbance level         :   625.00 m (GP   13)
-    Disturbances cease as soon as the disturbance energy exceeds 0.010 m**2/s**2
-    Random number generator used    : random-parallel
-
 
 