Index: palm/trunk/SOURCE/advec_s_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_pw.f90	(revision 3664)
+++ palm/trunk/SOURCE/advec_s_pw.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! nopointer option removed
 ! 
@@ -125,5 +128,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt
 
        USE kinds
@@ -192,5 +195,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
+           ONLY:  nzb, nzt
 
        USE kinds
Index: palm/trunk/SOURCE/advec_s_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_up.f90	(revision 3664)
+++ palm/trunk/SOURCE/advec_s_up.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! nopointer option removed
 ! 
@@ -122,5 +125,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt
 
        USE kinds
@@ -198,5 +201,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
+           ONLY:  nzb, nzt
 
        USE kinds
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 3664)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Fix output time levels (use time_since_reference_point)
 ! 
@@ -204,5 +207,5 @@
         
     USE surface_mod,                                                           &
-        ONLY :  surf_def_h, surf_lsm_h, surf_usm_h, get_topography_top_index_ji      
+        ONLY :  get_topography_top_index_ji
 
     IMPLICIT NONE
Index: palm/trunk/SOURCE/date_and_time_mod.f90
===================================================================
--- palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3664)
+++ palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! further tabs removed, unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! further tabs removed
 ! 
@@ -100,9 +103,7 @@
     INTEGER(iwp)        ::  hour_call_emis=0                        !< index used to call the emissions just once every hour
 
-    INTEGER(iwp)        ::  ihour            
     INTEGER(iwp)        ::  index_mm                                !< index months of the default emission mode
     INTEGER(iwp)        ::  index_dd                                !< index days of the default emission mode
     INTEGER(iwp)        ::  index_hh                                !< index hours of the emission mode
-    INTEGER(iwp)        ::  hours_since_reference_point             !< hours of current simulation
 
     REAL(wp)            ::  time_utc                     !< current model time in UTC
@@ -297,5 +298,5 @@
 
 !--    Variables Definition
-       INTEGER		   		:: i_mon       !< Index for going through the different months
+       INTEGER :: i_mon       !< Index for going through the different months
 
        !> Update simulation time in seconds
@@ -494,5 +495,5 @@
     !> ------------------------------------------------------------------------
 
-    INTEGER                	     :: weekday
+    INTEGER                          :: weekday
 
     !> CONSTANTS
@@ -542,19 +543,17 @@
 
     !> IN/OUTPUT
-    INTEGER, INTENT(INOUT) 		:: mo          !> Month
-    INTEGER, INTENT(INOUT) 		:: hh          !> Hour
-    INTEGER, INTENT(INOUT) 		:: dd          !> Day
-    INTEGER, INTENT(INOUT) 		:: index_hh    !> Index Hour
+    INTEGER, INTENT(INOUT)              :: mo          !> Month
+    INTEGER, INTENT(INOUT)              :: hh          !> Hour
+    INTEGER, INTENT(INOUT)              :: dd          !> Day
+    INTEGER, INTENT(INOUT)              :: index_hh    !> Index Hour
  
     !> Additional Variables for calculateing indices
-    INTEGER		   		:: index_mm    !> Index Month
-    INTEGER		   		:: index_dd    !> Index Day
-    INTEGER		   		:: i_mon       !> Index for going through the different months
-    INTEGER		   		:: sum_dd      !> Sum days
+    INTEGER                             :: index_mm    !> Index Month
+    INTEGER                             :: index_dd    !> Index Day
+    INTEGER                             :: i_mon       !> Index for going through the different months
+    INTEGER                             :: sum_dd      !> Sum days
 
     !> CONSTANTS
-    INTEGER, PARAMETER 			:: nmonth=12
-    INTEGER, PARAMETER 			:: nday = 7
-    INTEGER, PARAMETER 			:: nhour = 24
+    INTEGER, PARAMETER                  :: nhour = 24
     INTEGER, PARAMETER, DIMENSION(12)   :: days = (/31,28,31,30,31,30,31,31,30,31,30,31/) ! no leap year
     
Index: palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- palm/trunk/SOURCE/gust_mod.f90	(revision 3664)
+++ palm/trunk/SOURCE/gust_mod.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! dummy statements added to avoid compiler warnings about unused variables
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Bugfix: domain bounds of local_pf corrected
 ! 
@@ -52,5 +55,8 @@
     IMPLICIT NONE
 
-    LOGICAL  ::  gust_module_enabled = .FALSE.       !< switch, if the entire module is used at all
+    INTEGER(iwp) ::  idum  !< dummy variable used to avoid compiler warnings about unused variables
+
+    LOGICAL ::  dummy_logical = .FALSE.        !< switch to avoid compiler warnings about unused variables
+    LOGICAL ::  gust_module_enabled = .FALSE.  !< switch, if the entire module is used at all
 
     SAVE
@@ -228,4 +234,7 @@
        INTEGER(iwp) ::  var_count      !<
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = LEN( unit ) + LEN( variable ) + LEN( dopr_unit ) + var_count
 
     END SUBROUTINE gust_check_data_output_pr
@@ -244,4 +253,7 @@
        CHARACTER (LEN=*) ::  var   !<
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = LEN( var ) + LEN( unit )
 
     END SUBROUTINE gust_check_data_output
@@ -277,4 +289,7 @@
        CHARACTER (LEN=13), DIMENSION(dots_max) :: dots_label
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = dots_num + dots_max + LEN( dots_unit(1) ) + LEN( dots_label(1) )
 
     END SUBROUTINE gust_init
@@ -299,4 +314,7 @@
        CHARACTER (LEN=*), INTENT(IN) ::  grid_z      !<
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( found )  idum = LEN( var ) + LEN( grid_x ) + LEN( grid_y ) + LEN( grid_z )
 
     END SUBROUTINE gust_define_netcdf_grid
@@ -315,4 +333,7 @@
        INTEGER(iwp), INTENT(IN) ::  io  !< Unit of the output file
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = io
 
     END SUBROUTINE gust_header
@@ -331,4 +352,7 @@
        CHARACTER (LEN=*) ::  location !<
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = LEN( location )
 
     END SUBROUTINE gust_actions
@@ -350,4 +374,7 @@
        INTEGER(iwp) ::  j
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = i + j + LEN( location )
 
     END SUBROUTINE gust_actions_ij
@@ -364,6 +391,9 @@
        IMPLICIT NONE
 
-       INTEGER, INTENT(IN) :: mod_count
-
+       INTEGER, INTENT(IN) ::  mod_count
+
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = mod_count
 
     END SUBROUTINE gust_swap_timelevel
@@ -384,4 +414,7 @@
        CHARACTER (LEN=*) :: variable !<
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = LEN( mode ) + LEN( variable )
 
     END SUBROUTINE gust_3d_data_averaging
@@ -415,4 +448,7 @@
           !< array to which output data is resorted to
 
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( found .AND. two_d )  idum = av + LEN( variable ) + LEN( grid ) + local_pf(nxl,nys,nzb_do) + fill_value
 
     END SUBROUTINE gust_data_output_2d
@@ -441,6 +477,9 @@
 
        REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do), INTENT(INOUT) ::  local_pf   !< local
-          !< array to which output data is resorted to
-
+                                                                                        !< array to which output data is resorted to
+
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( found )  idum = av + LEN( variable ) + fill_value + local_pf(nxl,nys,nzb_do)
 
     END SUBROUTINE gust_data_output_3d
@@ -457,10 +496,13 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  mode   !<
-
-       INTEGER(iwp) ::  sr   !<
-       INTEGER(iwp) ::  tn   !<
+       CHARACTER (LEN=*) ::  mode  !<
+
        INTEGER(iwp) ::  dots_max   !<
-
+       INTEGER(iwp) ::  sr         !<
+       INTEGER(iwp) ::  tn         !<
+
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = dots_max + sr + tn + LEN( mode )
 
     END SUBROUTINE gust_statistics
@@ -543,11 +585,17 @@
        REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !<
 
-!
-!-- Here the reading of user-defined restart data follows:
-!-- Sample for user-defined output
-
-
+
+!
+!--    Next lins are just to avoid compiler warnings about unused variables in case of empty user interface routine.
+!--    You may remove them.
+       IF ( dummy_logical )  THEN
+          idum = i + k + nxlc + nxlf + nxrc + nxrf + nync + nynf + nysc + nysf +                                       &
+                 tmp_2d(nys_on_file,nxl_on_file) + tmp_3d(nzb,nys_on_file,nxl_on_file)
+       ENDIF
+
+!
+!--    Here the reading of user-defined restart data follows:
+!--    Sample for user-defined output
        found = .TRUE.
-
 
        SELECT CASE ( restart_string(1:length) )
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 3664)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -196,5 +199,5 @@
     
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_check_data_output
+        ONLY:  radiation_check_data_output
         
     USE salsa_mod,                                                             &
Index: palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 3664)
+++ palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3602 2018-12-04 16:03:51Z sward
 ! Added check for missing NAVIGATION_DATA input file
 ! 
@@ -1442,5 +1445,5 @@
 
 #endif
-          agents => NULL()
+          NULLIFY( agents )
 #if defined( __parallel )
           IF ( ALLOCATED( out_agents ) ) DEALLOCATE( out_agents )
@@ -2763,5 +2766,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  u, v, pt, hyp, exner
+           ONLY:  u, v, pt, exner
 
 !       USE chemistry_model_mod,                                                &
Index: palm/trunk/SOURCE/netcdf_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3664)
+++ palm/trunk/SOURCE/netcdf_interface_mod.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Statement added to prevent compiler warning about unused variable
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Move the control parameter "salsa" from salsa_mod to control_parameters 
 ! (M. Kurppa)
@@ -6777,6 +6780,10 @@
     INTEGER, INTENT(IN)           :: errno
     INTEGER, INTENT(OUT)          :: id
+    INTEGER                       :: idum  !< dummy variable used to avoid compiler warnings about unused variables
     LOGICAL, INTENT(IN)           :: parallel
 
+!
+!-- Next line is just to avoid compiler warning about unused variable
+    IF ( parallel )  idum = 0
 
 !
Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3664)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3665)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! unused variables removed
+! 
+! 3522 2018-11-13 12:14:36Z suehring
 ! Sampling of variables
 ! 
@@ -184,6 +187,6 @@
     INTEGER(iwp) ::  id_vm                           !< NetCDF file id for virtual measurements
     INTEGER(iwp) ::  nvm = 0                         !< number of virtual measurements
-    INTEGER(iwp) ::  observation_coverage_xy = 0     !< horizontal distance from the measurement point where observations should be taken in the surrounding 
-    INTEGER(iwp) ::  observation_coverage_z  = 0     !< vertical distance from the measurement point where observations should be taken in the surrounding 
+!    INTEGER(iwp) ::  observation_coverage_xy = 0     !< horizontal distance from the measurement point where observations should be taken in the surrounding
+!    INTEGER(iwp) ::  observation_coverage_z  = 0     !< vertical distance from the measurement point where observations should be taken in the surrounding
     
     LOGICAL ::  use_virtual_measurement = .FALSE. !< Namelist parameter
@@ -316,6 +319,5 @@
  
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  init_model, input_file_vm,                                      &
-               netcdf_data_input_get_dimension_length,                         &
+        ONLY:  input_file_vm, netcdf_data_input_get_dimension_length,          &
                netcdf_data_input_att, netcdf_data_input_var
                
@@ -329,14 +331,14 @@
     CHARACTER(LEN=10), DIMENSION(50) ::  measured_variables      = '' !< dummy array with all measured variables that are allowed   
     
-    INTEGER(iwp) ::  dim_eutm  !< dimension size of UTM easting coordinate
-    INTEGER(iwp) ::  dim_nutm  !< dimension size of UTM northing coordinate
+!    INTEGER(iwp) ::  dim_eutm  !< dimension size of UTM easting coordinate
+!    INTEGER(iwp) ::  dim_nutm  !< dimension size of UTM northing coordinate
     INTEGER(iwp) ::  dim_ntime !< dimension size of time coordinate 
-    INTEGER(iwp) ::  dim_zag   !< dimension size of height coordinate
-    INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
-    INTEGER(iwp) ::  ii        !< running index over all coordinate points of a measurement
+!    INTEGER(iwp) ::  dim_zag   !< dimension size of height coordinate
+!    INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
+!    INTEGER(iwp) ::  ii        !< running index over all coordinate points of a measurement
     INTEGER(iwp) ::  is        !< grid index of real observation point of the respective station in x-direction
-    INTEGER(iwp) ::  j         !< grid index of observation point in x-direction
+!    INTEGER(iwp) ::  j         !< grid index of observation point in x-direction
     INTEGER(iwp) ::  js        !< grid index of real observation point of the respective station in y-direction
-    INTEGER(iwp) ::  k         !< grid index of observation point in x-direction
+!    INTEGER(iwp) ::  k         !< grid index of observation point in x-direction
     INTEGER(iwp) ::  kl        !< lower vertical index of surrounding grid points of an observation coordinate
     INTEGER(iwp) ::  ks        !< grid index of real observation point of the respective station in z-direction
@@ -712,5 +714,5 @@
      IMPLICIT NONE
      
-     CHARACTER(LEN=10) ::  trimvar !< dummy for the measured variable name
+!     CHARACTER(LEN=10) ::  trimvar !< dummy for the measured variable name
       
      INTEGER(iwp) ::  i  !< grid index in x-direction