Index: /palm/trunk/TESTS/builds/pgi_mpi_only/build_config.yml
===================================================================
--- /palm/trunk/TESTS/builds/pgi_mpi_only/build_config.yml	(revision 3683)
+++ /palm/trunk/TESTS/builds/pgi_mpi_only/build_config.yml	(revision 3683)
@@ -0,0 +1,33 @@
+---
+# this is a palmtest build configuration file
+
+compiler:
+  id: PGI
+  executable: "{{PGI.executable}}"
+  mpi_wrapper: "{{PGI.mpi_wrapper}}"
+  definitions:
+    - "MPI_REAL=MPI_DOUBLE_PRECISION"
+    - "MPI_2REAL=MPI_2DOUBLE_PRECISION"
+    - "__parallel"
+  options:
+    default:
+      - "-cpp"
+      - "-w"
+      - "-fast"
+      - "-Mfree"
+      - "-Mfprelaxed"
+    debug:
+      - "-cpp"
+      - "-C"
+      - "-g"
+      - "-Minform=inform"
+      - "-Mchkfpstk"
+      - "-Mchkptr"
+      - "-Mchkstk"
+      - "-Mpgicoff"
+      - "-traceback"
+      - "-Mfree"
+  includes: []
+
+linker:
+  options: []
Index: /palm/trunk/TESTS/builds/pgi_mpi_openacc/build_config.yml
===================================================================
--- /palm/trunk/TESTS/builds/pgi_mpi_openacc/build_config.yml	(revision 3683)
+++ /palm/trunk/TESTS/builds/pgi_mpi_openacc/build_config.yml	(revision 3683)
@@ -0,0 +1,41 @@
+---
+# this is a palmtest build configuration file
+
+compiler:
+  id: PGI
+  executable: "{{PGI.executable}}"
+  mpi_wrapper: "{{PGI.mpi_wrapper}}"
+  definitions:
+    - "MPI_REAL=MPI_DOUBLE_PRECISION"
+    - "MPI_2REAL=MPI_2DOUBLE_PRECISION"
+    - "__parallel"
+    - "__cuda_fft"
+  options:
+    default:
+      - "-cpp"
+      - "-w"
+      - "-fast"
+      - "-Mfree"
+      - "-Mfprelaxed"
+      - "-ta=tesla"
+      - "-Minfo=accel"
+      - "-Mcuda"
+    debug:
+      - "-cpp"
+      - "-g"
+      - "-Minform=inform"
+      - "-Mchkfpstk"
+      - "-Mchkstk"
+      - "-Mpgicoff"
+      - "-traceback"
+      - "-Mfree"
+      - "-ta=tesla"
+      - "-Mcuda"
+      - "-Minfo=accel"
+  includes: []
+
+linker:
+  options:
+    - "-ta=tesla"
+    - "-Mcuda"
+    - "-Mcudalib=cufft"
Index: /palm/trunk/TESTS/cases/openacc_test/INPUT/openacc_test_p3d
===================================================================
--- /palm/trunk/TESTS/cases/openacc_test/INPUT/openacc_test_p3d	(revision 3683)
+++ /palm/trunk/TESTS/cases/openacc_test/INPUT/openacc_test_p3d	(revision 3683)
@@ -0,0 +1,70 @@
+!-------------------------------------------------------------------------------
+!-- INITIALIZATION PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/inipar
+!-------------------------------------------------------------------------------
+&initialization_parameters
+!
+!-- grid parameters
+!-------------------------------------------------------------------------------
+    nx                         = 39, ! Number of gridboxes in x-direction (nx+1)
+    ny                         = 39, ! Number of gridboxes in y-direction (ny+1)
+    nz                         = 40, ! Number of gridboxes in z-direction (nz)
+
+    dx                         = 50.0, ! Size of single gridbox in x-direction
+    dy                         = 50.0, ! Size of single gridbox in y-direction
+    dz                         = 50.0, ! Size of single gridbox in z-direction
+
+    dz_stretch_level           = 1225.0, ! Height (in m) where stretching starts
+    dz_stretch_factor          = 1.08,   ! dz(k+1) = dz(k) * dz_stretch_factor
+!
+!-- initialization
+!-------------------------------------------------------------------------------
+    initializing_actions       = 'set_constant_profiles', ! initial conditions
+    loop_optimization          = 'vector', ! use 'cache' or 'vector'
+
+    ug_surface                 = 0.0, ! u-comp of geostrophic wind at surface
+    vg_surface                 = 0.0, ! v-comp of geostrophic wind at surface
+
+    pt_surface                 = 300.0, ! initial surface potential temp
+
+    pt_vertical_gradient       =    0.0,
+                                    1.0, ! piecewise temp gradients
+    pt_vertical_gradient_level =    0.0,
+                                  800.0, ! height level of temp gradients
+
+
+!
+!-- boundary conditions
+!-------------------------------------------------------------------------------
+    surface_heatflux           = 0.1, ! sensible heat flux at the bottom surface
+    bc_pt_b                    = 'neumann', ! required with surface_heatflux
+!
+!-- numerics
+!-------------------------------------------------------------------------------
+    fft_method                 = 'temperton-algorithm', ! build-in fft method
+
+/ ! end of initialization parameter namelist
+
+!-------------------------------------------------------------------------------
+!-- RUNTIME PARAMETER NAMELIST
+!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/d3par
+!-------------------------------------------------------------------------------
+&runtime_parameters
+!
+!-- run steering
+!-------------------------------------------------------------------------------
+    end_time                   = 60.0, ! simulation time of the 3D model
+
+    create_disturbances        = .TRUE., ! randomly perturbate horiz. velocity
+    dt_disturb                 = 150.0,  ! interval for random perturbations
+    disturbance_energy_limit   = 0.01,   ! upper limit for perturbation energy
+
+    data_output_2d_on_each_pe  = .FALSE., ! don't do 2D output on each MPI rank
+
+!
+!-- data output
+!-------------------------------------------------------------------------------
+    dt_run_control             = 0.0,    ! output interval for run control
+
+/ ! end of runtime parameter namelist
+ 
Index: /palm/trunk/TESTS/cases/openacc_test/MONITORING/openacc_test_rc
===================================================================
--- /palm/trunk/TESTS/cases/openacc_test/MONITORING/openacc_test_rc	(revision 3683)
+++ /palm/trunk/TESTS/cases/openacc_test/MONITORING/openacc_test_rc	(revision 3683)
@@ -0,0 +1,187 @@
+
+ ******************************    --------------------------------------------
+ * PALM 6.0  Rev: 3678:36     *    atmosphere - run without 1D - prerun
+ ******************************    --------------------------------------------
+
+ Date:               2019-01-20    Run:       openacc_test_small__pgi_openacc__1
+ Time:                 03:36:17    Run-No.:   00
+ Run on host:        pgi_openac
+ Number of PEs:               1    Processor grid (x,y): (   1,   1) calculated
+                                   A 1d-decomposition along x is used
+ ------------------------------------------------------------------------------
+
+ Numerical Schemes:
+ -----------------
+
+ --> Use the Moeng_Wyngaard turbulence closure (LES mode).
+ --> Use the boussinesq approximation for the model equations.
+ --> Solve perturbation pressure via FFT using system-specific routines
+     perturbation pressure is calculated at every Runge-Kutta step
+ --> Momentum advection via Wicker-Skamarock-Scheme 5th order
+ --> Scalar advection via Wicker-Skamarock-Scheme 5th order
+ --> Loop optimization method: vector
+ --> Time differencing scheme: runge-kutta-3       
+ ------------------------------------------------------------------------------
+
+
+ Run time and time step information:
+ ----------------------------------
+
+ Timestep:             variable     maximum value: 20.000 s    CFL-factor: 0.90
+ Start time:              0.000 s
+ End time:               60.000 s
+
+
+ Computational grid and domain size:
+ ----------------------------------
+
+ Grid length:      dx =      50.000 m    dy =      50.000 m
+                dz(1) =      50.000 m
+                dz(2) =     999.000 m
+
+ Domain size:       x =   2000.000 m     y =   2000.000 m  z(u) =   2862.511 m
+
+ Vertical stretching starts at height:    1225.0 m,
+ Vertical stretching starts at index:           25,
+ Vertical stretching ends at height:   9999999.9 m,
+ Vertical stretching ends at index:             41,
+ Factor used for stretching:                 1.080,
+
+ Number of gridpoints (x,y,z):  (0:  39, 0:  39, 0:  41)
+ Subdomain size (x,y,z):        (    40,     40,     42)
+
+
+    Characteristic levels of the geo. wind component ug:
+
+       Height:         0.0     0.0  m
+       ug:            0.00    0.00  m/s
+       Gradient:    ------    0.00  1/100s
+       Gridpoint:        0       0
+
+    Characteristic levels of the geo. wind component vg:
+
+       Height:         0.0     0.0  m
+       vg:            0.00    0.00  m/s
+       Gradient:    ------    0.00  1/100s
+       Gridpoint:        0       0
+
+
+ Topography information:
+ ----------------------
+
+ Topography: flat                                    
+
+
+ Boundary conditions:
+ -------------------
+
+                     p                    uv                                  pt
+
+ B. bound.: p(0)     = p(1)   | uv(0)     = -uv(1)                | pt(0)     = pt(1)            
+ T. bound.: p(nzt+1) = 0      | uv(nzt+1) = ug(nzt+1), vg(nzt+1)  | pt(nzt+1) = pt(nzt) + dpt/dz_
+
+                     e
+
+ B. bound.: e(0)     = e(1)                                                                      
+ T. bound.: e(nzt+1) = e(nzt) = e(nzt-1)                                                         
+
+ Bottom surface fluxes are used in diffusion terms at k=1
+       Predefined constant heatflux:    0.100000 K m/s
+
+
+    Constant flux layer between bottom surface and first computational u,v-level:
+
+       z_mo =  25.00 m   z0 = 0.1000 m   z0h = 0.10000 m   kappa = 0.40
+       Rif value range:     -20.00 <= rif <= 20.00
+
+
+ Lateral boundaries:
+       left/right:  cyclic              
+       north/south: cyclic              
+
+
+ Initial profiles:
+ ----------------
+
+    Characteristic levels of the initial temperature profile:
+
+       Height:           0.0     0.0   800.0  m
+       Temperature:   300.00  300.00  300.00  K
+       Gradient:      ------    0.00    1.00  K/100m
+       Gridpoint:          0       0      16
+
+
+ List output:
+ -----------
+
+    1D-Profiles:
+       Output every             9999999.90 s
+
+
+ Data output:
+ -----------
+
+
+    Time series:
+       Output format: netCDF 64bit offset                     
+
+       Output every                 0.00 s
+
+ ------------------------------------------------------------------------------
+
+
+ Physical quantities:
+ -------------------
+
+    Geograph. latitude  :   latitude  = 55.0 degr
+    Geograph. longitude :   longitude =  0.0 degr
+    Angular velocity    :   omega  = 0.729E-04 rad/s
+    Coriolis parameter  :   f      =  0.000119 1/s
+                            f*     =  0.000084 1/s
+
+    Day of the year at model start :   day_init      =     172
+    UTC time at model start        :   time_utc_init = 43200.0 s
+
+    Gravity             :   g      =  9.8 m/s**2
+
+    Reference state used in buoyancy terms: initial_profile
+
+
+ Cloud physics quantities / methods:
+ ----------------------------------
+
+
+
+ LES / Turbulence quantities:
+ ---------------------------
+
+    Mixing length is limited to 1.80 * z
+
+
+ Actions during the simulation:
+ -----------------------------
+
+    Disturbance impulse (u,v) every :   150.00 s
+    Disturbance amplitude           :     0.25 m/s
+    Lower disturbance level         :   125.00 m (GP    3)
+    Upper disturbance level         :   625.00 m (GP   13)
+    Disturbances cease as soon as the disturbance energy exceeds 0.010 m**2/s**2
+    Random number generator used    : random-parallel
+
+
+
+ *** no user-defined variables found
+
+ ------------------------------------------------------------------------------
+
+
+
+Run-control output:
+------------------
+
+RUN  ITER. HH:MM:SS.SS    DT(E)     UMAX     VMAX     WMAX     U*    W*      THETA*     Z_I     ENERG.   DISTENERG    DIVOLD     DIVNEW     UMAX(KJI)    VMAX(KJI)    WMAX(KJI)   ADVECX   ADVECY   MGCYC
+---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
+  0      0 00:00:00.00  20.0000A  -0.2131D -0.2288D  0.1182  0.000  1.38   0.000E+00    800.  0.104E-02  0.103E-02  0.597E-03  0.867E-13    7   7  11   11   7  19    5  26   7    0.000    0.000       0
+  0      1 00:00:20.00  20.0000D  -0.2125  -0.2273   0.1172  0.009  0.69  -0.132E+02    100.  0.103E-02  0.102E-02  0.570E-05  0.411E-15    7   7  11   11   7  19    5  26   7    0.000    0.000       0
+  0      2 00:00:40.00  20.0000D  -0.2117  -0.2252   0.1162  0.009  0.69  -0.133E+02    100.  0.102E-02  0.102E-02  0.935E-05  0.416E-15    7   7  11   11   7  19    5  26   7    0.000    0.000       0
+  0      3 00:01:00.00  20.0000D  -0.2106  -0.2227   0.1152  0.009  0.69  -0.134E+02    100.  0.101E-02  0.101E-02  0.130E-04  0.421E-15    7   7  11   11   7  19    5  26   7    0.000    0.000       0
Index: /palm/trunk/TESTS/cases/openacc_test/case_config.yml
===================================================================
--- /palm/trunk/TESTS/cases/openacc_test/case_config.yml	(revision 3683)
+++ /palm/trunk/TESTS/cases/openacc_test/case_config.yml	(revision 3683)
@@ -0,0 +1,22 @@
+---
+# this is a palmtest job configuration file
+
+allowed_builds:
+  - pgi_mpi_only
+  - pgi_mpi_openacc
+
+allowed_number_of_cores:
+  - 1
+  - 2
+  - 4
+  - 8
+  - 16
+  - 32
+
+activation_strings:
+  - "d3#"
+
+significant_digits_for_netcdf_checks:
+  timeseries: 8
+  profiles: 8
+  other: 8