Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3683)
+++ palm/trunk/SOURCE/Makefile	(revision 3684)
@@ -1342,4 +1342,5 @@
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
+	user_actions.o \
 	user_read_restart_data_mod.o \
 	user_write_restart_data_mod.o \
@@ -1400,6 +1401,5 @@
 	modules.o \
 	pmc_interface_mod.o \
-	surface_mod.o \
-	user_actions.o
+	surface_mod.o
 outflow_turbulence.o: \
 	cpulog_mod.o \
@@ -1541,5 +1541,5 @@
 	mod_kinds.o \
 	mod_kinds.o \
-	modules.o \
+	module_interface.o \
 	modules.o \
 	ocean_mod.o \
@@ -1551,5 +1551,4 @@
 	surface_mod.o \
 	turbulence_closure_mod.o \
-	user_actions.o \
 	wind_turbine_model_mod.o
 progress_bar_mod.o: \
@@ -1691,5 +1690,4 @@
 	data_output_flight.o \
 	disturb_heatflux.o \
-	gust_mod.o \
 	indoor_model_mod.o \
 	interaction_droplets_ptq.o \
@@ -1715,5 +1713,4 @@
 	turbulence_closure_mod.o\
 	urban_surface_mod.o \
-	user_actions.o \
 	vertical_nesting_mod.o \
 	virtual_flight_mod.o \
@@ -1767,6 +1764,5 @@
 	pmc_interface_mod.o \
 	surface_layer_fluxes_mod.o \
-	surface_mod.o \
-	user_actions.o
+	surface_mod.o
 urban_surface_mod.o: \
 	basic_constants_and_equations_mod.o \
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3683)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3684)
@@ -130,4 +130,5 @@
               gust_check_data_output,                                          &
               gust_header,                                                     &
+              gust_actions,                                                    &
               gust_swap_timelevel,                                             &
               gust_3d_data_averaging,                                          &
@@ -240,4 +241,7 @@
               usm_rrd_local,                                                   &
               usm_wrd_local
+
+   USE user_actions_mod,                                                       &
+       ONLY:  user_actions
 
    USE user_read_restart_data_mod,                                             &
@@ -637,4 +641,9 @@
 
 
+   IF ( gust_module_enabled )  CALL gust_actions( location )
+
+   CALL user_actions( location ) ! ToDo: make user module switch
+
+
 END SUBROUTINE module_interface_actions
 
@@ -651,4 +660,9 @@
    INTEGER(iwp),      INTENT(IN) ::  j         !< grid index in y-direction
    CHARACTER (LEN=*), INTENT(IN) ::  location  !< call location string
+
+
+   IF ( gust_module_enabled )  CALL gust_actions( i, j, location )
+
+   CALL user_actions( i, j, location ) ! ToDo: make user module switch
 
 
Index: palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- palm/trunk/SOURCE/ocean_mod.f90	(revision 3683)
+++ palm/trunk/SOURCE/ocean_mod.f90	(revision 3684)
@@ -1504,7 +1504,4 @@
                surf_usm_v
 
-    USE user_actions_mod,                                                      &
-        ONLY:  user_actions
-
     IMPLICIT NONE
 
@@ -1575,5 +1572,5 @@
                          surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
 
-       CALL user_actions( 'sa-tendency' )
+!       CALL user_actions( 'sa-tendency' ) ToDo: find general solution for dependency between modules
 
 !
@@ -1667,7 +1664,4 @@
                surf_usm_v
 
-    USE user_actions_mod,                                                      &
-        ONLY:  user_actions
-
     IMPLICIT NONE
 
@@ -1720,5 +1714,5 @@
                          surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
 
-       CALL user_actions( i, j, 'sa-tendency' )
+!       CALL user_actions( i, j, 'sa-tendency' ) ToDo: find general solution for dependency between modules
 
 !
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3683)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3684)
@@ -409,4 +409,7 @@
         ONLY:  ls_advec, nudge
 
+    USE module_interface,                                                      &
+        ONLY:  module_interface_actions
+
     USE ocean_mod,                                                             &
         ONLY:  ocean_prognostic_equations, stokes_drift_terms, stokes_force,   &
@@ -442,7 +445,4 @@
         ONLY:  tcm_prognostic_equations
 
-    USE user_actions_mod,                                                      &
-        ONLY:  user_actions
-
     USE wind_turbine_model_mod,                                                &
         ONLY:  wtm_tendencies
@@ -694,5 +694,5 @@
              IF ( wind_turbine )  CALL wtm_tendencies( i, j, 1 )
 
-             CALL user_actions( i, j, 'u-tendency' )
+             CALL module_interface_actions( i, j, 'u-tendency' )
 !
 !--          Prognostic equation for u-velocity component
@@ -777,5 +777,5 @@
              IF ( wind_turbine )  CALL wtm_tendencies( i, j, 2 )
 
-             CALL user_actions( i, j, 'v-tendency' )
+             CALL module_interface_actions( i, j, 'v-tendency' )
 !
 !--          Prognostic equation for v-velocity component
@@ -856,5 +856,5 @@
           IF ( wind_turbine )  CALL wtm_tendencies( i, j, 3 )
 
-          CALL user_actions( i, j, 'w-tendency' )
+          CALL module_interface_actions( i, j, 'w-tendency' )
 !
 !--       Prognostic equation for w-velocity component
@@ -944,5 +944,5 @@
 
 
-             CALL user_actions( i, j, 'pt-tendency' )
+             CALL module_interface_actions( i, j, 'pt-tendency' )
 !
 !--          Prognostic equation for potential temperature
@@ -1029,5 +1029,5 @@
              ENDIF
 
-             CALL user_actions( i, j, 'q-tendency' )
+             CALL module_interface_actions( i, j, 'q-tendency' )
 
 !
@@ -1350,5 +1350,5 @@
              ENDIF
 
-             CALL user_actions( i, j, 's-tendency' )
+             CALL module_interface_actions( i, j, 's-tendency' )
 
 !
@@ -1615,5 +1615,5 @@
     IF ( wind_turbine )  CALL wtm_tendencies( 1 )
 
-    CALL user_actions( 'u-tendency' )
+    CALL module_interface_actions( 'u-tendency' )
 
 !
@@ -1722,5 +1722,5 @@
     IF ( wind_turbine )  CALL wtm_tendencies( 2 )
 
-    CALL user_actions( 'v-tendency' )
+    CALL module_interface_actions( 'v-tendency' )
 
 !
@@ -1825,5 +1825,5 @@
     IF ( wind_turbine )  CALL wtm_tendencies( 3 )
 
-    CALL user_actions( 'w-tendency' )
+    CALL module_interface_actions( 'w-tendency' )
 
 !
@@ -1957,5 +1957,5 @@
        ENDIF
 
-       CALL user_actions( 'pt-tendency' )
+       CALL module_interface_actions( 'pt-tendency' )
 
 !
@@ -2081,5 +2081,5 @@
        ENDIF
 
-       CALL user_actions( 'q-tendency' )
+       CALL module_interface_actions( 'q-tendency' )
 
 !
@@ -2556,5 +2556,5 @@
        ENDIF
 
-       CALL user_actions( 's-tendency' )
+       CALL module_interface_actions( 's-tendency' )
 
 !
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3683)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3684)
@@ -514,7 +514,4 @@
         ONLY:  flight_measurement
 
-    USE gust_mod,                                                              &
-        ONLY:  gust_actions, gust_module_enabled
-
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, &
@@ -537,4 +534,7 @@
     USE lsf_nudging_mod,                                                       &
         ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_actions
 
     USE multi_agent_system_mod,                                                &
@@ -616,8 +616,5 @@
         ONLY:  dt_stg_call, dt_stg_adjust, parametrize_inflow_turbulence,      &
                stg_adjust, stg_main, time_stg_adjust, time_stg_call,           &
-               use_syn_turb_gen   
-
-    USE user_actions_mod,                                                      &
-        ONLY:  user_actions
+               use_syn_turb_gen
 
 
@@ -836,12 +833,6 @@
 
 !
-!--    Execute the gust module actions
-       IF ( gust_module_enabled )  THEN
-          CALL gust_actions( 'before_timestep' )
-       ENDIF
-
-!
-!--    Execute the user-defined actions
-       CALL user_actions( 'before_timestep' )
+!--    Execute alle other module actions routunes
+       CALL module_interface_actions( 'before_timestep' )
 
 !
@@ -1531,12 +1522,6 @@
 
 !
-!--    Execute the gust module actions
-       IF ( gust_module_enabled )  THEN
-          CALL gust_actions( 'after_integration' )
-       ENDIF
-
-!
-!--    Execute user-defined actions
-       CALL user_actions( 'after_integration' )
+!--    Execute alle other module actions routunes
+       CALL module_interface_actions( 'after_integration' )
 
 !
@@ -1762,12 +1747,6 @@
 
 !
-!--    Execute the gust module actions
-       IF ( gust_module_enabled )  THEN
-          CALL gust_actions( 'after_timestep' )
-       ENDIF
-
-!
-!--    Execute user-defined actions
-       CALL user_actions( 'after_timestep' )
+!--    Execute alle other module actions routunes
+       CALL module_interface_actions( 'after_timestep' )
 
 !
Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3683)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3684)
@@ -233,7 +233,4 @@
         ONLY:  hom, hom_sum, statistic_regions
 
-    USE user_actions_mod,                                                      &
-        ONLY:  user_actions
-
 
     IMPLICIT NONE
@@ -2003,5 +2000,5 @@
        IF ( plant_canopy )  CALL pcm_tendency( 6 )
 
-       CALL user_actions( 'e-tendency' )
+!       CALL user_actions( 'e-tendency' ) ToDo: find general solution for circular dependency between modules
 
 !
@@ -2110,5 +2107,5 @@
 !        IF ( plant_canopy )  CALL pcm_tendency( ? )         !> @todo not yet implemented
 
-!        CALL user_actions( 'diss-tendency' )                !> @todo not yet implemented
+!       CALL user_actions( 'e-tendency' ) ToDo: find general solution for circular dependency between modules
 
 !
@@ -2222,5 +2219,5 @@
        IF ( plant_canopy )  CALL pcm_tendency( i, j, 6 )
 
-       CALL user_actions( i, j, 'e-tendency' )
+!       CALL user_actions( i, j, 'e-tendency' ) ToDo: find general solution for circular dependency between modules
 
 !
@@ -2284,5 +2281,5 @@
 !        IF ( plant_canopy )  CALL pcm_tendency( i, j, ? )     !> @todo not yet implemented
 
-!        CALL user_actions( i, j, 'diss-tendency' )            !> @todo not yet implemented
+!       CALL user_actions( i, j, 'diss-tendency' ) ToDo: find general solution for circular dependency between modules
 
 !
Index: palm/trunk/SOURCE/user_flight.f90
===================================================================
--- palm/trunk/SOURCE/user_flight.f90	(revision 3683)
+++ palm/trunk/SOURCE/user_flight.f90	(revision 3684)
@@ -1,3 +1,3 @@
-!> @file user_actions.f90
+!> @file user_flight.f90
 !------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.